# coding: utf-8

"""
    Payment Gateway API Specification.

    Payment Gateway API for payment processing. Version 6.4.0.20181018.001   # noqa: E501

    OpenAPI spec version: 6.4.0.20181018.001
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class PaymentTokenizationRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'type': 'str',
        'payment_card': 'PaymentCard',
        'referenced_order': 'ReferencedOrder',
        'billing_address': 'Address'
    }

    attribute_map = {
        'type': 'type',
        'payment_card': 'paymentCard',
        'referenced_order': 'referencedOrder',
        'billing_address': 'billingAddress'
    }

    def __init__(self, type=None, payment_card=None, referenced_order=None, billing_address=None):  # noqa: E501
        """PaymentTokenizationRequest - a model defined in OpenAPI"""  # noqa: E501

        self._type = None
        self._payment_card = None
        self._referenced_order = None
        self._billing_address = None
        self.discriminator = None

        self.type = type
        if payment_card is not None:
            self.payment_card = payment_card
        if referenced_order is not None:
            self.referenced_order = referenced_order
        if billing_address is not None:
            self.billing_address = billing_address

    @property
    def type(self):
        """Gets the type of this PaymentTokenizationRequest.  # noqa: E501

        Use this to indicate the type of tokenization source  # noqa: E501

        :return: The type of this PaymentTokenizationRequest.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this PaymentTokenizationRequest.

        Use this to indicate the type of tokenization source  # noqa: E501

        :param type: The type of this PaymentTokenizationRequest.  # noqa: E501
        :type: str
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501
        allowed_values = ["PAYMENT_CARD", "EXISTING_ORDER"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def payment_card(self):
        """Gets the payment_card of this PaymentTokenizationRequest.  # noqa: E501


        :return: The payment_card of this PaymentTokenizationRequest.  # noqa: E501
        :rtype: PaymentCard
        """
        return self._payment_card

    @payment_card.setter
    def payment_card(self, payment_card):
        """Sets the payment_card of this PaymentTokenizationRequest.


        :param payment_card: The payment_card of this PaymentTokenizationRequest.  # noqa: E501
        :type: PaymentCard
        """

        self._payment_card = payment_card

    @property
    def referenced_order(self):
        """Gets the referenced_order of this PaymentTokenizationRequest.  # noqa: E501


        :return: The referenced_order of this PaymentTokenizationRequest.  # noqa: E501
        :rtype: ReferencedOrder
        """
        return self._referenced_order

    @referenced_order.setter
    def referenced_order(self, referenced_order):
        """Sets the referenced_order of this PaymentTokenizationRequest.


        :param referenced_order: The referenced_order of this PaymentTokenizationRequest.  # noqa: E501
        :type: ReferencedOrder
        """

        self._referenced_order = referenced_order

    @property
    def billing_address(self):
        """Gets the billing_address of this PaymentTokenizationRequest.  # noqa: E501


        :return: The billing_address of this PaymentTokenizationRequest.  # noqa: E501
        :rtype: Address
        """
        return self._billing_address

    @billing_address.setter
    def billing_address(self, billing_address):
        """Sets the billing_address of this PaymentTokenizationRequest.


        :param billing_address: The billing_address of this PaymentTokenizationRequest.  # noqa: E501
        :type: Address
        """

        self._billing_address = billing_address

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PaymentTokenizationRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
